#include "cell.h"

Cell::Cell() {
    _isEmpty = true;
    _isLocked = false;
    _grainId = 0;
    _onBorder = false;
    _willGrown = true;
    _recristalized = false;
    _energy = 10;

}

Cell::Cell(const Cell & src) {
    _isEmpty = src._isEmpty;
    _isLocked = src._isLocked;
    _grainId = src._grainId;
    _onBorder = src._onBorder;
    _willGrown = src._willGrown;
    _recristalized = src._recristalized;
    _energy = src._energy;
}

void Cell::setGrainId(int id) {
    _grainId = id;
    _isEmpty = false;
}

int Cell::getGrainId() {
    return _grainId;
}

bool Cell::isEmpty() {
    return _isEmpty;
}

bool Cell::onBorder() {
    return _onBorder;
}

void Cell::setOnBorder(bool val) {
    _onBorder = val;
}

void Cell::lock() {
    _isLocked = true;
}

bool Cell::isLocked() {
    return _isLocked;
}

double Cell::getEnergy(){
    return _energy;
}

void Cell::setEnergy(double energy) {
    _energy = energy;
}

bool Cell::willGrown() {
    return _willGrown;
}

void Cell::setWillGrown(bool val) {
    _willGrown = val;
}

void Cell::setRecristalized(bool val) {
    _recristalized = val;
}

bool Cell::getRecristalized() {
    return _recristalized;
}
