#ifndef CELL_H
#define CELL_H

struct CellLocation {
    int x;
    int y;
};

class Cell {
private:
    bool _isEmpty;
    bool _isLocked;
    bool _onBorder;
    bool _willGrown;
    bool _recristalized;
    int _grainId;
    double _energy;

public:
    Cell();
    Cell(const Cell & src);

    void setGrainId(int id);
    int getGrainId(void);

    bool isEmpty(void);

    bool onBorder(void);
    void setOnBorder(bool val);

    void lock(void);
    bool isLocked(void);

    double getEnergy(void);
    void setEnergy(double energy);

    bool willGrown(void);
    void setWillGrown(bool val);

    void setRecristalized(bool val);
    bool getRecristalized(void);

};

#endif // CELL_H
