#include "class3.h"
#include <QDebug>


/* Zwraca:
 * > 0 zmień ID ziarna na wartość
 *  0  nie zmieniaj wartości
 * < 0
*/
int Class3Simulation::_rule1(QVector<QVector<Cell> > &cells, int x, int y) {
    static bool mask[3][3] = {
        { true, true, true },
        { true, false, true },
        { true, true, true }
    };

    int id, max;


    max = _calcutateNeighbors(cells, x, y, mask, &id);

    if (max >= 5) {
        return id;
    }

    return 0;
}

int Class3Simulation::_rule2(QVector<QVector<Cell> > &cells, int x, int y) {
    static bool mask[3][3] = {
        { false, true, false },
        { true, false, true },
        { false, true, false }
    };

    int id, max;

    max = _calcutateNeighbors(cells, x, y, mask, &id);

    if (max == 3) {
        return id;
    }

    return 0;
}

int Class3Simulation::_rule3(QVector<QVector<Cell> > &cells, int x, int y) {
    static bool mask[3][3] = {
        { true, false, true },
        { false, false, false },
        { true, false, true }
    };

    int id, max;

    max = _calcutateNeighbors(cells, x, y, mask, &id);

    if (max == 3) {
        return id;
    }

    return 0;
}

int Class3Simulation::_rule4(QVector<QVector<Cell> > &cells, int x, int y) {
    static bool mask[3][3] = {
        { true, true, true },
        { true, false, true },
        { true, true, true }
    };

    int id, max;


    max = _calcutateNeighbors(cells, x, y, mask, &id);

    if ((max > 0) && (rand() % 2)) {
        return id;
    }

    return 0;
}

Class3Simulation::Class3Simulation() {

}

bool Class3Simulation::step(QVector<QVector<Cell> > &src, QVector<QVector<Cell> > &dest, bool boundaryPeriodic, QVector<CellLocation> &emptyCells) {

    for(int i = 0; i < emptyCells.count(); i++) {
        int x = emptyCells[i].x;
        int y = emptyCells[i].y;
        int newid;

        if (!src[x][y].isEmpty()) {
            qDebug() << "Not empty cell at" << x << "," << y << "on empty cell list, removing cell from list";
            emptyCells.remove(i--);
            continue;
        }

        if (src[x][y].isLocked())
            continue;

        newid = _rule1(src, x, y);
        if (newid > 0) {
            dest[x][y].setGrainId(newid);
            emptyCells.remove(i--);
            continue;
        }

        newid = _rule2(src, x, y);
        if (newid > 0) {
            dest[x][y].setGrainId(newid);
            emptyCells.remove(i--);
            continue;
        }

        newid = _rule4(src, x, y);
        if (newid > 0) {
            dest[x][y].setGrainId(newid);
            emptyCells.remove(i--);
        }
    }

    _updateBorders(dest);
    return emptyCells.isEmpty();
}
