#ifndef SRX_H
#define SRX_H

#include "simulation.h"
#include "montecarlo.h"

class SRX : public MonteCarlo {
private:
    void _addNucletions(int count, QVector<QVector<Cell> > &cells);
    bool _canRecrystalize(int x, int y, QVector<QVector<Cell> > &cells);
    double _getNeighboursEnergy(int x, int y, QVector<QVector<Cell> > &cells);
    bool _MCSRX(int x, int y, QVector<QVector<Cell> > &cells);
public:
    SRX();
    bool step(QVector<QVector<Cell> > & src, QVector<QVector<Cell> > & dest, bool boundaryPeriodic, QVector<struct CellLocation> & emptyCells);
};

#endif // SRX_H
