#ifndef WNDMAIN_H
#define WNDMAIN_H

#include <QMainWindow>
#include "space.h"
#include "simulation.h"
#include <QGraphicsScene>

namespace Ui {
    class WndMain;
}

class WndMain : public QMainWindow {
    Q_OBJECT

private:
    Ui::WndMain * _ui;

    QGraphicsScene * _previewScene;
    Space * _space;
    Simulation * _simulation;

private slots:
    void _reset(void);
    void _start(void);

    void _class1(void);
    void _class3(void);
    void _mc(void);
    void _srx(void);

    void _drawEnergy(void);
    void _drawSpace(void);

    void _distributeEnergy(void);

    void _inclusions(void);
    void _addStartPoints(void);

public:
    explicit WndMain(QWidget *parent = 0);
    ~WndMain();
    
protected:
    void changeEvent(QEvent *e);    

};

#endif // WNDMAIN_H
